Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.dropboxmq.messageconsumers
Class MessageConsumerImpl

    java.lang.Object
      net.sf.dropboxmq.messageconsumers.MessageConsumerImpl

All Implemented Interfaces:
  MessageConsumer

Direct Known Subclasses:
  QueueReceiverImpl, TopicSubscriberImpl

    public abstract class MessageConsumerImpl

extends Object
implements MessageConsumer

Created: 10 Mar 2006

Version:
  $Revision: 231 $, $Date: 2011-08-12 21:50:47 -0600 (Fri, 12 Aug 2011) $
Author:
  Dwayne Schultz

Constructor Summary
`protected` | `MessageConsumerImpl(SessionImpl session, DestinationImpl destination, String messageSelector, String subscriptionName, boolean durable, boolean noLocal)`

Method Summary
`void` | `close()` Closes the message consumer.
`Dropbox` | `getDropbox()`
`MessageListener` | `getMessageListener()` Gets the message consumer's `MessageListener`.
`String` | `getMessageSelector()` Gets this message consumer's message selector expression.
`String` | `getSubscriptionName()`
`boolean` | `isDurable()`
`Message` | `receive()` Receives the next message produced for this message consumer.
`Message` | `receive(long timeout)` Receives the next message that arrives within the specified timeout interval.
`Message` | `receiveNoWait()` Receives the next message if one is immediately available.
`void` | `setMessageListener(MessageListener listener)` Sets the message consumer's `MessageListener`.
`void` | `start()`
`void` | `stop()`
`void` | `stopMessageListener()` Allows for quicker two phase shutdown.
`protected String` | `toObjectString()`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MessageConsumerImpl

    protected MessageConsumerImpl(SessionImpl session,
                                  DestinationImpl destination,
                                  String messageSelector,
                                  String subscriptionName,
                                  boolean durable,
                                  boolean noLocal)
                           throws JMSException

Throws:
  `JMSException`

Method Detail

### getMessageSelector

    public String getMessageSelector()
                              throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Gets this message consumer's message selector expression.

  Specified by:
    `getMessageSelector` in interface `MessageConsumer`
  Returns:
    this message consumer's message selector, or null if no message selector exists for the message consumer (that is, if the message selector was not set or was set to null or the empty string)
  Throws:
    `JMSException` - if the JMS provider fails to get the message selector due to some internal error.

### getMessageListener

    public MessageListener getMessageListener()
                                       throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Gets the message consumer's `MessageListener`.

  Specified by:
    `getMessageListener` in interface `MessageConsumer`
  Returns:
    the listener for the message consumer, or null if no listener is set
  Throws:
    `JMSException` - if the JMS provider fails to get the message listener due to some internal error.
  See Also:
    `MessageConsumer.setMessageListener(javax.jms.MessageListener)`

### setMessageListener

    public void setMessageListener(MessageListener listener)
                            throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Sets the message consumer's `MessageListener`.

  Setting the message listener to null is the equivalent of unsetting the message listener for the message consumer.

  The effect of calling `MessageConsumer.setMessageListener` while messages are being consumed by an existing listener or the consumer is being used to consume messages synchronously is undefined.

  Specified by:
    `setMessageListener` in interface `MessageConsumer`
  Parameters:
    `listener` - the listener to which the messages are to be delivered
  Throws:
    `JMSException` - if the JMS provider fails to set the message listener due to some internal error.
  See Also:
    `MessageConsumer.getMessageListener()`

### receive

    public Message receive()
                    throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Receives the next message produced for this message consumer.

  This call blocks indefinitely until a message is produced or until this message consumer is closed.

  If this `receive` is done within a transaction, the consumer retains the message until the transaction commits.

  Specified by:
    `receive` in interface `MessageConsumer`
  Returns:
    the next message produced for this message consumer, or null if this message consumer is concurrently closed
  Throws:
    `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

### receive

    public Message receive(long timeout)
                    throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Receives the next message that arrives within the specified timeout interval.

  This call blocks until a message arrives, the timeout expires, or this message consumer is closed. A `timeout` of zero never expires, and the call blocks indefinitely.

  Specified by:
    `receive` in interface `MessageConsumer`
  Parameters:
    `timeout` - the timeout value (in milliseconds)
  Returns:
    the next message produced for this message consumer, or null if the timeout expires or this message consumer is concurrently closed
  Throws:
    `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

### receiveNoWait

    public Message receiveNoWait()
                          throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Receives the next message if one is immediately available.

  Specified by:
    `receiveNoWait` in interface `MessageConsumer`
  Returns:
    the next message produced for this message consumer, or null if one is not available
  Throws:
    `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

### close

    public void close()
               throws JMSException

  Description copied from interface: `javax.jms.MessageConsumer`
  Closes the message consumer.

  Since a provider may allocate some resources on behalf of a `MessageConsumer` outside the Java virtual machine, clients should close them when they are not needed. Relying on garbage collection to eventually reclaim these resources may not be timely enough.

  This call blocks until a `receive` or message listener in progress has completed. A blocked message consumer `receive` call returns null when this message consumer is closed.

  Specified by:
    `close` in interface `MessageConsumer`
  Throws:
    `JMSException` - if the JMS provider fails to close the consumer due to some internal error.

### start

    public void start()
               throws JMSException

  Throws:
    `JMSException`

### stop

    public void stop()
              throws JMSException

  Throws:
    `JMSException`

### stopMessageListener

    public void stopMessageListener()

  Allows for quicker two phase shutdown.

### getSubscriptionName

    public String getSubscriptionName()

### isDurable

    public boolean isDurable()

### getDropbox

    public Dropbox getDropbox()

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### toObjectString

    protected final String toObjectString()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD